Attribute VB_Name = "DataPumpAPI"
Option Explicit

' NeuroShell Trader requires data in Eastern Time Zone for the local/eastern time zone settings
' - to work properly and for red bar to update.  This constant is the number of hours to add
' - to your local time to adjust to eastern time zone for the random number generator in this example.
'
' - When loading from a data provider, the data will usually be either already in eastern time
' - zone or will need to be converted to eastern timezone from the data providers default
' - time zone given to data (for instance GMT, or other)

Public TimeZoneBias As Double    ' Adjustment to current time zone to get data to eastern time zone

Public Declare Sub SetDataFeedhwnd Lib "NSTFEED.DLL" (ByVal hWnd As Long)
Public Declare Sub UpdatePercent Lib "NSTFEED.DLL" (ByVal Percent As Long)
Public Declare Sub RequireUserIDPassword Lib "NSTFEED.DLL" ()
Public Declare Sub GetUserIDPassword Lib "NSTFEED.DLL" (ByRef UserID As String, ByRef Password As String)

Public Declare Function NSTSETUPDATA Lib "NSTFEED.DLL" (ByVal ticker As String, ByVal description As String, ByVal BarInt As Single, ByVal NumColumns As Long, ByVal Category As String, ByVal FirstDateAvailable As Double) As Long
Public Declare Function NSTSETLABEL Lib "NSTFEED.DLL" (ByVal ticker As String, ByVal BarInt As Single, ByVal Column As Long, ByVal LabelName As String) As Long
Public Declare Function NSTSETVALUE Lib "NSTFEED.DLL" (ByVal ticker As String, ByVal BarInt As Single, ByVal Column As Long, ByVal value As Double) As Long
Public Declare Function NSTCOMMITROW Lib "NSTFEED.DLL" (ByVal ticker As String, ByVal BarInt As Single) As Long

Private Declare Function GetTimeZoneInformation Lib "kernel32" (lpTimeZoneInformation As TIME_ZONE_INFORMATION) As Long

Private Type SYSTEMTIME
    wYear As Integer 'String * 2
    wMonth As Integer 'String * 2
    wDayOfWeek As Integer 'String * 2
    wDay As Integer 'String * 2
    wHour As Integer 'String * 2
    wMinute As Integer 'String * 2
    wSecond As Integer 'String * 2
    wMilliseconds As Integer 'String * 2
End Type

Private Type TIME_ZONE_INFORMATION
    TimeZoneBias As Long
    StandardName As String * 64
    StandardDate As SYSTEMTIME
    StandardTimeZoneBias As Long
    DaylightName As String * 64
    DaylightDate As SYSTEMTIME
    DaylightTimeZoneBias As Long
End Type

Public Sub Main()
'This allows the server to be running but have no interface.
' - This is the most dersirable situation so that users don't get confused by the NeuroShell Trader interface
' - and the Server Interface.  It will be running in the background and will work seemlessly with NeuroShell Trader
' - Initially you probably want to have the interface visible to debug the process, but in your final version you should turn hide the interface
Const HideInterface = False

    Dim lpTimeZoneInformation As TIME_ZONE_INFORMATION
    Dim x As Long
    Dim SubtractTime As Double
    
    lpTimeZoneInformation.DaylightDate.wMonth = 0
    lpTimeZoneInformation.StandardDate.wMonth = 0
    x = GetTimeZoneInformation(lpTimeZoneInformation)
        
    'If x = 2 Then
    '    SubtractTime = 4 / 24 '4 hours
    '    TimeZoneBias = lpTimeZoneInformation.TimeZoneBias - 60
    'Else
        SubtractTime = 5 / 24 '5 hours to eastern time zone
        TimeZoneBias = lpTimeZoneInformation.TimeZoneBias
    'End If
    
    TimeZoneBias = TimeZoneBias / (24 * 60) - SubtractTime

#If HideInterface Then
    Load DataPump
#Else
    DataPump.Show 1
#End If
End Sub

